periods=2000;
var C, OMEGA, U, DELTA, H, M, Y, K, I, X, LAMBDA, MIU, PHIS,W,OMEGAN,z,zc2,zc3;  //Endogenous variables; note that z in endogenous

varexo e;                                       //Exogenous variables, they must be iid

parameters alpha, beta, gamma, rho,SDP,Utilcoef,sigma,theta,GP,GDP,US,G1,gammai,xsi;      //Parameters
parameters alpha, beta, gamma, rho,SDP,Utilcoef,sigma,theta,GP,GDP,US,G1,gammai,xsi,TB_Y,Rval;
parameters Acoef,Axc,Kval1,Kval2,KStarget,YStarget,UStarget,HStarget,delta2,a1,a2 ;
parameters IStarget,CStarget,XStarget,Axc,BStarget,xsi1,xsi2,xsi3,PHIStarget,LAMBDAStarget;
parameters PHIS1,PHIS12,LAMBDAS1,LAMBDAS2,MIUStarget,XStarget,TBStarget,eta,eta2;
parameters aa1,aa2,v,bcoef,Utilcoef,Starget,ValueStarget,gammabeta,gammaq,V,k_co,Profitstarget,gamman,Drts,LStarget;


%
alpha 	 = 0.64;
k_co     = 1-alpha;
beta  	 = 0.985;
gammabeta = beta;
gamma 	 = 0.001;
SDP   	 =1.3;
Utilcoef = 0.15; 
theta 	 = 1.4000;
gammai	 = SDP;
gamman   = 0;
sigma  =1;
rho=1;
xsi      =  5.1755;
US       = 1;
delta2   = 0.0125; 

UStarget=1;
HStarget=1/5;
LStarget=1;
Drts=1;
Acoef=1-gamma;
Kval1=1/beta-(1-delta2);
Kval2=Drts*(1-alpha)*HStarget^(Drts*alpha)*LStarget^(1-Drts);
KStarget=(Kval1/Kval2)^(1/(Drts*(1-alpha)-1));
IStarget=KStarget*delta2;
YStarget=(KStarget^(1-alpha)*HStarget^alpha)^Drts*LStarget^(1-Drts);
WStarget=(alpha*Drts)*YStarget/HStarget;
CStarget=YStarget-IStarget;
XStarget=CStarget;
xsi1=theta*HStarget^(theta-1)*XStarget/WStarget;
xsi2=HStarget^theta*gamma;
xsi3=(1-beta*(1-gamma));
xsi=1/(xsi1+xsi2/xsi3);
MStarget=CStarget*(1-xsi*HStarget^theta);
PHIS1=MStarget^(-sigma)*xsi*HStarget^theta;
PHIS2=1-beta*(1-gamma);
PHIStarget=PHIS1/PHIS2;
LAMBDAS1=MStarget^(-sigma)*xsi*theta*HStarget^(theta-1)*XStarget;
LAMBDAS2=alpha*Drts*(YStarget/HStarget);
LAMBDAStarget=LAMBDAS1/LAMBDAS2;
MIUStarget=LAMBDAStarget;
GPUS     = (1-alpha)*Drts*YStarget/KStarget;
     GP = GPUS/UStarget;
     GDP=Utilcoef*GPUS/UStarget^2 %0.19
     G1=GP*UStarget;
     GDP*UStarget/GP
Profitstarget=(1-k_co-alpha)*YStarget;
//Starget=MStarget^(-sigma)*((1-alpha)*YStarget-IStarget);
//ValueStarget=1/MStarget^(-sigma)*1/(1-beta)*Starget;
model;                                          //After the instruction model type the equilibrium conditions

//1) FOC C
             exp(M)^(-sigma) - exp(LAMBDA) -  gamma*exp(PHIS)*exp(C)^(gamma-1)*exp(X(-1))^(1-gamma);
//2) FOC N
             exp(M)^(-sigma)*xsi*theta*exp(H)^(theta-1)*exp(X)-alpha*Drts*exp(LAMBDA)*exp(Y)/exp(H)
             +exp(LAMBDA)*exp(OMEGAN)*gamman*(exp(OMEGAN)-1)+exp(LAMBDA)*(gamman/2)*(exp(OMEGAN)-1)^2
             -beta*exp(LAMBDA(+1))*(exp(OMEGAN(+1)))^2*gamman*(exp(OMEGAN(+1))-1) ;


              exp(OMEGAN) - exp(H)/exp(H(-1));
//3) FOC U
             exp(LAMBDA)*(1-alpha)*Drts*exp(Y)-exp(U)*exp(MIU)*GP*exp(K(-1))*(exp(U)^(GDP*US/GP));             
//4) Def delta
          //  exp(DELTA)   + (1-delta2)- exp(U)^G1; 
  exp(DELTA)  -delta2 + GP/(1+Utilcoef) - GP/(1+Utilcoef)*exp(U)^(1+Utilcoef); 
//5) RC
             exp(Y) - exp(C) -exp(I)-exp(H)*(gamman/2)*(exp(OMEGAN)-1)^2;
//6) Def M
              exp(M)-(exp(C)-xsi*exp(H)^theta*exp(X));     
//7) Def Y1
              exp(Y)-exp(z)*((exp(U)*exp(K(-1)))^(1-alpha)*exp(H)^alpha)^Drts*LStarget^(1-Drts);   
//9) FOC K'
              exp(MIU) - beta*exp(MIU(+1))*(1-exp(DELTA(+1))) -beta*exp(LAMBDA(+1))*(1-alpha)*Drts*exp(Y(+1))/exp(K);
//10) FOC I
              -exp(LAMBDA)  +exp(MIU)- exp(MIU)*(gammai/2)*(exp(OMEGA)-1)^2- 
              exp(MIU)*exp(OMEGA)*gammai*(exp(OMEGA)-1) 
              + beta*exp(MIU(+1))*(exp(OMEGA(+1)))^2*gammai*(exp(OMEGA(+1))-1);                                                                             
//11) K law of motion     
              exp(K) - (1-exp(DELTA))*exp(K(-1))- exp(I)*(1-(gammai/2)*(exp(OMEGA)-1)^2); 
//12) I law of motion
              exp(OMEGA) - exp(I)/exp(I(-1));
//13) X law of motion
              exp(X)-exp(C)^gamma*exp(X(-1))^(1-gamma);
//14) FOC X
            exp(PHIS)- beta*exp(PHIS(+1))*(1-gamma)*exp(C(+1))^gamma*exp(X)^(-gamma) -exp(M)^(-sigma)*xsi*exp(H)^theta;   
//15) Firm Value

        exp(W)-alpha*Drts*exp(Y)/exp(H) +exp(OMEGAN)*gamman*(exp(OMEGAN)-1)
             -beta*(exp(OMEGAN(+1)))^2*gamman*(exp(OMEGAN(+1))-1);
 z=zc2(-1);
            zc2=zc3(-1);
            zc3=zc3(-1)+e;
end;

initval;                        // initval defines either the initial conditions or the initial guesses to solve for steady state
C= log(CStarget);
U=log(UStarget);
DELTA=log(delta2);
H=log(HStarget);
Y=log(YStarget);
K=log(KStarget);
W=log(WStarget);
I=log(IStarget);
LAMBDA=log(LAMBDAStarget);
MIU=log(MIUStarget);
PHIS=log(PHIStarget);
M=log(MStarget);
//Profits=log(Profitstarget);
X=log(XStarget);
//Valuefirm=log(ValueStarget);
e=0;
z=0;
end;
//shocks;
//var e = 0.01;
//end;
//steady;
//stoch_simul (order = 1,irf=4) Y H C I z;


shocks;
    var e;
    periods 1:1  ;
    values 0.01      ;
var e;
    periods  2:3;
    values .0    ;
    var e;
    periods 4:1000;
    values 0.00;
end;

//check;
simul;