function F = ss_JMCB(x,pars);

alphaC=pars(1);
alpha_i=pars(2);
beta=pars(3);
sigma=pars(4);
theta=pars(5);
delta2=pars(6);
HStarget_I=pars(7);
KStarget_I=pars(8);
KStarget_C=pars(9);
IStarget=pars(10);
gamma=pars(11);

HStarget_C=x(1)

CStarget=KStarget_C^(1-alphaC)*HStarget_C^alphaC

HStarget=HStarget_C+HStarget_I

XStarget=CStarget
xsi1=theta*HStarget^(theta-1)/(alphaC/HStarget_C)
xsi2=HStarget^theta*gamma
xsi3=(1-beta*(1-gamma))
xsi=1/(xsi1+xsi2/xsi3)
MStarget=CStarget*(1-xsi*HStarget^theta)

Lambda_C=xsi*theta*HStarget^(theta-1)/(1-xsi*HStarget^theta)/alphaC*(HStarget_C)/CStarget


Lambda_I=xsi*theta*HStarget^(theta-1)/(1-xsi*HStarget^theta)/(alpha_i*IStarget/HStarget_I)

F=[1/beta-(1-delta2)-Lambda_C/Lambda_I*(1-alphaC)*CStarget/KStarget_C;];